| Flutter Impeller |

Public Member Functions | Protected Member Functions | List of all members
impeller::StrokeRoundSuperellipseGeometry Class Referencefinal

A Geometry class that produces fillable vertices representing the stroked outline of any |RoundSuperellipse| object regardless of radii uniformity. More...

`#include <round_superellipse_geometry.h>`

Inheritance diagram for impeller::StrokeRoundSuperellipseGeometry:

## Public Member Functions
| StrokeRoundSuperellipseGeometry (const RoundSuperellipse &round_superellipse, const StrokeParameters &parameters)
Public Member Functions inherited from impeller::StrokeSegmentsGeometry
| ~StrokeSegmentsGeometry () override
Scalar | GetStrokeWidth () const
Scalar | GetMiterLimit () const
Cap | GetStrokeCap () const
Join | GetStrokeJoin () const
Scalar | ComputeAlphaCoverage (const Matrix &transform) const override
Public Member Functions inherited from impeller::Geometry
virtual | ~Geometry ()
virtual bool | CoversArea (const Matrix &transform, const Rect &rect) const
| Determines if this geometry, transformed by the given `transform`, will completely cover all surface area of the given `rect`. More...
virtual bool | IsAxisAlignedRect () const
virtual bool | CanApplyMaskFilter () const

## Protected Member Functions
const PathSource & | GetSource () const override
Protected Member Functions inherited from impeller::StrokePathSourceGeometry
| StrokePathSourceGeometry (const StrokeParameters &parameters)
std::optional< Rect > | GetCoverage (const Matrix &transform) const override
void | Dispatch (PathAndArcSegmentReceiver &receiver, Tessellator &tessellator, Scalar scale) const override
Protected Member Functions inherited from impeller::StrokeSegmentsGeometry
| StrokeSegmentsGeometry (const StrokeParameters &parameters)
std::optional< Rect > | GetStrokeCoverage (const Matrix &transform, const Rect &segment_bounds) const

## Additional Inherited Members
Static Public Member Functions inherited from impeller::Geometry
static std::unique_ptr< Geometry > | MakeFillPath (const flutter::DlPath &path, std::optional< Rect > inner_rect=std::nullopt)
static std::unique_ptr< Geometry > | MakeStrokePath (const flutter::DlPath &path, const StrokeParameters &stroke={})
static std::unique_ptr< Geometry > | MakeCover ()
static std::unique_ptr< Geometry > | MakeRect (const Rect &rect)
static std::unique_ptr< Geometry > | MakeOval (const Rect &rect)
static std::unique_ptr< Geometry > | MakeLine (const Point &p0, const Point &p1, const StrokeParameters &stroke)
static std::unique_ptr< Geometry > | MakeCircle (const Point &center, Scalar radius)
static std::unique_ptr< Geometry > | MakeStrokedCircle (const Point &center, Scalar radius, Scalar stroke_width)
static std::unique_ptr< Geometry > | MakeFilledArc (const Rect &oval_bounds, Degrees start, Degrees sweep, bool include_center)
static std::unique_ptr< Geometry > | MakeStrokedArc (const Rect &oval_bounds, Degrees start, Degrees sweep, const StrokeParameters &stroke)
static std::unique_ptr< Geometry > | MakeRoundRect (const Rect &rect, const Size &radii)
static std::unique_ptr< Geometry > | MakeRoundSuperellipse (const Rect &rect, Scalar corner_radius)
static Scalar | ComputeStrokeAlphaCoverage (const Matrix &entity, Scalar stroke_width)
| Compute an alpha value to simulate lower coverage of fractional pixel strokes. More...
static GeometryResult | ComputePositionGeometry (const ContentContext &renderer, const Tessellator::VertexGenerator &generator, const Entity &entity, RenderPass &pass)

## Detailed Description

A Geometry class that produces fillable vertices representing the stroked outline of any |RoundSuperellipse| object regardless of radii uniformity.

This class uses the |StrokePathSourceGeometry| base class to do the work by providing a |RoundSuperellipsePathSoure| iterator.

See also
  |RoundSuperellipseGeometry|

Definition at line 69 of file round_superellipse_geometry.h.

## Constructor & Destructor Documentation

## ◆ StrokeRoundSuperellipseGeometry()

impeller::StrokeRoundSuperellipseGeometry::StrokeRoundSuperellipseGeometry | ( | const RoundSuperellipse & | round_superellipse,
|  | const StrokeParameters & | parameters
| ) |  |

Definition at line 466 of file round_superellipse_geometry.cc.

469 : StrokePathSourceGeometry(parameters),
470 round_superellipse_source_(round_superellipse) {}
impeller::StrokePathSourceGeometry::StrokePathSourceGeometry
StrokePathSourceGeometry(const StrokeParameters &parameters)
Definition: stroke_path_geometry.cc:839

## Member Function Documentation

## ◆ GetSource()

const PathSource & impeller::StrokeRoundSuperellipseGeometry::GetSource | ( |  | ) | const
| override protected virtual

The PathSource object that will be iterated to produce the raw vertices to be stroked.

Implements impeller::StrokePathSourceGeometry.

Definition at line 472 of file round_superellipse_geometry.cc.

472 {
473 return round_superellipse_source_;
474 }

The documentation for this class was generated from the following files:

- impeller/entity/geometry/round_superellipse_geometry.h
- impeller/entity/geometry/round_superellipse_geometry.cc